/*
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details. 
 *
 * octeon_soft_trace.h 
 *    octeon SMP software trace facility
 *
 * Copyright (C) 2008 Cavium Networks
 */

#ifndef __OCTEON_SOFT_TRACE_H__
#define __OCTEON_SOFT_TRACE_H__

// #define OCT_SOFT_TRACE_ENABLE

#ifdef OCT_SOFT_TRACE_ENABLE
#define OCTEON_SOFT_TRACE_PERCPU_BUF_SIZE 150
#else
#define OCTEON_SOFT_TRACE_PERCPU_BUF_SIZE 0
#endif 

int octeon_soft_trace_add_event(const char* filen, const char* funcn, 
	int line, int num_p, int p0, int p1, int p2, int p4);

#ifdef  OCT_SOFT_TRACE_ENABLE
  #define OCTEON_SOFT_TRACE_EVENT  octeon_soft_trace_add_event (__FILE__, __FUNCTION__, __LINE__,  0, 0, 0, 0 ,0)	

  #define OCTEON_SOFT_TRACE_EVENT_4W(p0, p1, p2, p3)  \
		octeon_soft_trace_add_event (__FILE__, __FUNCTION__, \
		__LINE__,  4, p0, p1, p2, p3)	

  #define OCTEON_SOFT_TRACE_EVENT_3W(p0, p1, p2)  \
		octeon_soft_trace_add_event (__FILE__, __FUNCTION__, \
		__LINE__,  3, p0, p1, p2, 0)	

  #define OCTEON_SOFT_TRACE_EVENT_2W(p0, p1)  \
		octeon_soft_trace_add_event (__FILE__, __FUNCTION__, \
		__LINE__,  2, p0, p1, 0 , 0)	

  #define OCTEON_SOFT_TRACE_EVENT_1W(p0)  \
		octeon_soft_trace_add_event (__FILE__, __FUNCTION__, \
		__LINE__,  1, p0, 0, 0 , 0)	

#else  /* ifdef  OCT_SOFT_TRACE_ENABLE */
  #define OCTEON_SOFT_TRACE_EVENT  
  #define OCTEON_SOFT_TRACE_EVENT_4W(p0, p1, p2, p3) 
  #define OCTEON_SOFT_TRACE_EVENT_3W(p0, p1, p2) 
  #define OCTEON_SOFT_TRACE_EVENT_2W(p0, p1) 
  #define OCTEON_SOFT_TRACE_EVENT_1W(p0) 
#endif  /* ifdef  OCT_SOFT_TRACE_ENABLE */

#endif
